//
// Module: DetmapFilter
// Author: Hassan Siddiqui
//
// Description:
//
// Given an input detmap, this class generates
// a new PixelIterator for those pixels
// that are bounded by the specified region expression.
//
// Modifications: See ChangeLog
//
// $Id: DetmapFilter.h,v 1.3 2009/09/03 13:19:51 aibarra Exp $

#ifndef DetmapFilter_H
#define DetmapFilter_H

// General classes
#include <iostream>

// SAS-specific classes

// General utility functions

// Local classes
#include "DatafileAttributes.h"
#include "PixelIterator.h"

class DetmapFilter
{
public:

  /* Constructor */
  DetmapFilter();

  /* Destructor */
  ~DetmapFilter();

  /* Accessors */
  /* AI gcc4 porting
   *   error: type qualifiers ignored on function return type
   *   => XXX * const removed
   */
  PixelIterator *  filteredMap(PixelIterator * const detmap,
                       const string & rawtablename,
                       DatafileAttributes * dfAttributes,
                       const DataSubspace * dss,
                       bool insitu);

private:

  bool _init;

  DataSet * _filteredset;
  DataSet * set;

  PixelIterator *  _t;

};

#endif
